﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamMenuRequirements
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void OnMenuItemLoaded(object sender, RoutedEventArgs e)
        {
            BehaviorCollection bc = Interaction.GetBehaviors(sender as DependencyObject);
            if (bc.Where(b => b.GetType() == typeof(MenuItemShiftChildren)).FirstOrDefault() == null)
                bc.Add(new MenuItemShiftChildren());
        }
    }

    public class MyMenuItem
    {
        public string MenuName { get; set; }

        public ObservableCollection<MyMenuItem> ChildMenus { get; set; }
    }

    public class MenuItemsCollection : ObservableCollection<MyMenuItem>
    {
        public MenuItemsCollection()
        {
            this.Add(new MyMenuItem { MenuName = "File", ChildMenus = new ObservableCollection<MyMenuItem>() });
            this.Add(new MyMenuItem { MenuName = "Edit", ChildMenus = new ObservableCollection<MyMenuItem>() });

            this[0].ChildMenus.Add(new MyMenuItem { MenuName = "New" });
            this[0].ChildMenus.Add(new MyMenuItem { MenuName = "Open" });
            this[0].ChildMenus.Add(new MyMenuItem { MenuName = "Save" });
            this[0].ChildMenus.Add(new MyMenuItem { MenuName = "Close" });

            this[1].ChildMenus.Add(new MyMenuItem { MenuName = "Copy" });
            this[1].ChildMenus.Add(new MyMenuItem { MenuName = "Paste" });
            this[1].ChildMenus.Add(new MyMenuItem { MenuName = "Cut" });
        }
    }
}
