﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Interactivity;
using System.Windows.Media;
using Infragistics.Controls.Menus;
using Infragistics.Windows;

namespace XamMenuRequirements
{
    public class MenuItemShiftChildren : Behavior<XamMenuItem>
    {
        Popup _menuPopup;
        XamMenu _parentMenu;

        protected override void OnAttached()
        {
            base.OnAttached();

            _menuPopup = (Popup)Utilities.GetDescendantFromName(AssociatedObject, "Popup");
            if (_menuPopup != null)
                _menuPopup.Opened += _menuPopup_Opened;
            else
                AssociatedObject.Loaded += AssociatedObject_Loaded;

            //_parentMenu = (XamMenu)Utilities.GetAncestorFromType(AssociatedObject, typeof(XamMenu), false);
        }

        void AssociatedObject_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            _menuPopup = (Popup)Utilities.GetDescendantFromName(AssociatedObject, "Popup");
            if (_menuPopup != null)
            {
                _menuPopup.Opened += _menuPopup_Opened;
            }
        }

        void _menuPopup_Opened(object sender, EventArgs e)
        {
            StackPanel sp = (StackPanel)VisualTreeHelper.GetParent(AssociatedObject);
            var transform = AssociatedObject.TransformToVisual(sp);
            Point absolutePosition = transform.Transform(new Point(0, 0));

            _menuPopup.HorizontalOffset = -absolutePosition.X;
        }
    }
}
